package kow.functional

import scala.concurrent.Future
import scala.concurrent.ExecutionContext.Implicits.global


object MonadExample {
  def main(args: Array[String]): Unit = {
    //------------------------------------------------------------------
    //option monad
    Option("test").map { value => value.toUpperCase() }
    val none: Option[String] = None
    none.map { value => value.toUpperCase }

    val oa: Option[String] = Some("a")
    val ob: Option[String] = Some("b")

    val oab: Option[String] = for {
      a <- oa
      b <- ob
    } yield a + b

    val oab2: Option[Option[String]] = oa.map{a => ob.map{b => a + b}}

    //------------------------------------------------------------------

    //multiple monad
    val lst = List(Future.successful(1),Future.successful(3),Future.successful(6))
    import scalaz._
    import Scalaz._
    
    val seq: Future[List[Int]] = lst.sequence


  }
}
