package kow.functional

object PatternMatching {

  def checktype(x: Any) = x match {
    case i: Int => println("I am an Int")
    case str: String => println("I am a String")
  }

  def listStructure(lst: List[Int]) = lst match {
    case _ :: _ :: c :: Nil => println(c)
    case List(_, _, 1) => println("one")
  }

  trait MyList
  case class Cons(head: Int, tail: MyList) extends MyList
  case object MyNil extends MyList

  def myListMatching(lst: MyList) = lst match {
    case Cons(a, MyNil) => println(s"One element is $a")
    case Cons(a, Cons(b, MyNil)) => println(s"two element which are $a and $b")
  }

  def main(args: Array[String]): Unit = {

    //------------------------------------------------------------------
    //pattern on types
    checktype(3)
    checktype("kow sama")
    checktype(2.5)

    //pattern match on list structure
    listStructure(List(1, 2, 3))
    listStructure(List(3, 2, 1))
    listStructure(List(2, 3))

    //------------------------------------------------------------------
    //pattern on MyList
    myListMatching(Cons(5, MyNil))
    myListMatching(Cons(5, Cons(7, MyNil)))

  }
}
